/////////////////////////////////////////////////////////////////////
//Note, this code was originally written by Matt Weir, at Florida State University
//Contact Info weir -at- cs.fsu.edu
//This code is licensed GPLv2
//If you make any changes I would love to hear about them so I don't have to impliment them myself ;)
//Note, this code was intentionally slowed down to not hammer wikipedia's servers
//Don't be a mooch.  Contribute to wikipedia.  They provide a great service.  
//Oh, and yes, I was an idiot for writing this in C.  It started out as a test case that I just
//threw together and then I didn't want to recode the entire thing

#include <sys/types.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <signal.h>

#define MAXNUMURLS 400
#define MAXURL 200
#define MAXLINE 8000
#define MINWORDSIZE 4 
#define MAXWORDSIZE 50
#define MAXUSERINPUT 50
#define MAXCOMMAND 500
#define MAXCHOICES 500
#define MAXDESC 200
#define SLEEPVALUE 2  //How long it waits between grabbing pages, set to 0 to disable

typedef struct urlStruct {
  char mainURL[MAXURL];
  char siteURL[MAXURL];
  char fileName[MAXURL];
  char followedURLs[MAXNUMURLS][MAXURL]; 
  int numURLs;
  char rejectedURLs[MAXNUMURLS][MAXURL];
  int numRejectedURLs;
  int depth;    //The maximum depth to spider URLs
  int urlDepth[MAXNUMURLS]; //Holds which depth the URL was added with
  int mode;     //0=aggressive, 1=cautious, 2=user directed
} urlType;

typedef struct choiceStruct {
  char url[MAXCHOICES][MAXURL];
  char topic[MAXCHOICES][MAXURL];
  char desc[MAXCHOICES][MAXDESC];
  int numChoice;
} choiceType;


void sig_alrm(int signo)
{
  printf("exiting\n");
  exit(0);
}

int getURLs(urlType *myURL);
int getWords(FILE * outputFile);
int insertURL(urlType *myURL, char* newURL, int depth);
int insertWord(FILE *outputFile,char *tempLine);
int getSettings(FILE * outputFile,urlType *myURL);
int pickLanguage(FILE * outputFile,urlType *myURL);
int pickIndex(FILE *outputFile, urlType *myURL);
int grabLanguage(FILE *outputFile,urlType* myURL);
int pickTopic(FILE *outputFile, urlType *myURL);
int pickSubject(FILE *outputFile,urlType *myURL);
int findSubjects(urlType *myURL,choiceType *userChoice,char *userInput);
int spiderdata(FILE *outputFile, urlType *myURL);
int getSubjectWords(FILE *outputFile);
int getSubjectURLs(urlType *myURL, int curDepth);
int insertSubjectURL(urlType *myURL,char *newURL, char *description, int depth, int urlLevel);


int main(int argc, char *argv[]) {
  FILE * outputFile;
  urlType myURL;
  struct sigaction action;
/*-----------------Signal Initilization--------------*/
  action.sa_handler = sig_alrm;
  sigemptyset(&action.sa_mask);
  action.sa_flags = 0;
  sigaction(SIGINT, &action, 0);
  sigaction(SIGKILL, &action, 0);
  sigaction(SIGTERM, &action, 0);
  sigaction(SIGALRM, &action, 0);

/*-----------------End Signal Initilization----------*/
  myURL.numURLs=0;
  myURL.numRejectedURLs=0;
  myURL.mode=0;
  if (getSettings(outputFile,&myURL) ==-1) {
    printf("\nExiting\n");
    return 0;
  }

  return 0;
}



int getWords(FILE * outputFile) {
  FILE * inputFile;
  char *startChar1;
  char *startChar2;
  char *startChar;
  char *endChar;
  char tempLine[MAXLINE];
  char curLine[MAXLINE];
  int done;
  printf("getword\n");
  done=0;
  inputFile=fopen("tempFile.txt","r");
  if (inputFile==NULL) {
    printf("ERROR can not open outputfile for writing\n");
    return -1;
  }
  fgets(curLine,MAXLINE,inputFile);
  while (!feof(inputFile)) {
    startChar1=strstr(curLine,"href=\"/wiki/");
    startChar2=strstr(curLine,"href=\"/w/index.php");
    if ((startChar1!=NULL)&&(startChar2!=NULL)) {
      if (startChar1<startChar2) {
        startChar = startChar1;
      }
      else { 
        startChar = startChar2;
      }
    }
    else if (startChar1!=NULL) {
      startChar=startChar1;
    }
    else if (startChar2!=NULL) {
      startChar=startChar2;
    }
    else {
      startChar=NULL;
    }
    while (startChar!=NULL) {
      startChar=strstr(startChar," title=\"");
      if (startChar!=NULL) {
        startChar=strstr(startChar,"\">");
        if (startChar==NULL) {
          break;
        }
      }
      else {
        break;
      }
      startChar=startChar+2;
      endChar=strstr(startChar,"</a>");
      if (endChar!=NULL) {
        endChar[0]='\0';
        strcpy(tempLine,startChar);
        strcpy(curLine,endChar+1);
        done = insertWord(outputFile,tempLine);
        if (done==1) {
          fclose(inputFile);
          return 0;
        }
      }
      else {
        curLine[0]='\0';
      }
      
      startChar1=strstr(curLine,"href=\"/wiki/");
      startChar2=strstr(curLine,"href=\"/w/index.php");
      if ((startChar1!=NULL)&&(startChar2!=NULL)) {
        if (startChar1<startChar2) {
          startChar = startChar1;
        }
        else {
          startChar = startChar2;
        }
      }
      else if (startChar1!=NULL) {
        startChar=startChar1;
      }
      else if (startChar2!=NULL) {
        startChar=startChar2;
      }
      else {
        startChar=NULL;
      }

    } 
    fgets(curLine,MAXLINE,inputFile);
  }
  fclose(inputFile);
  return 1;


}


int getURLs(urlType *myURL) {
  char curLine[MAXLINE];
  char backupLine[MAXLINE];
  char tempLine[MAXLINE];
  FILE * inputFile;
  char * startChar;
  char * endChar;
  char currentURL[MAXURL];

  inputFile=fopen("tempFile.txt","r");
  if (inputFile==NULL) {
    printf("ERROR can not open outputfile for writing\n");
    return -1;
  }
  fgets(curLine,MAXLINE,inputFile);
  while (!feof(inputFile)) {
    strncpy(backupLine,curLine,MAXLINE);
    startChar=strstr(curLine,"href=\"/wiki/Index:");
    while (startChar!=NULL) {
      strcpy(tempLine,startChar+6);
      endChar=strchr(startChar+6,'\"'); 
      if (endChar!=NULL) {
        strcpy(curLine,endChar+1); 
        endChar=strchr(tempLine+8,'\"');
        if (endChar!=NULL) {
          endChar[0]='\0';
          insertURL(myURL,tempLine,0);
        }
      }
      else {
        curLine[0]='\0';
      }
      startChar=strstr(curLine,"href=\"/wiki/Index:");
    }
    //////////////////////////////////////////////////////
    //Get the (next 200)  Yah, they are a pain
    if (strstr(backupLine,"next 200")!=NULL) {
      startChar=strstr(backupLine,"href=\"/w/index.php?title=");
      if (startChar!=NULL) {
        printf("startChar=%s\n",startChar);
        startChar=strstr(startChar+10,"href=\"/w/index.php?title=");
        if (startChar==NULL) {
          startChar=strstr(backupLine,"href=\"/w/index.php?title=");
          printf("Grabbing the first\n");
        }
        else printf("Grabbing the second\n");
        startChar=startChar+6;
        strncpy(tempLine,startChar,MAXLINE);
        endChar=strstr(tempLine,"amp;");
        if (endChar!=NULL) {
          endChar[0]='\0';
          startChar=strstr(startChar,"amp;");
          if (startChar!=NULL) {
            endChar=strchr(startChar,'\"');
            if (endChar!=NULL) {
              endChar[0]='\0';
              strncat(tempLine,startChar+4,MAXLINE);
              printf("---Inserting %s\n",tempLine);
              insertURL(myURL,tempLine,0);
            }
          }
        }
      }
    }
    
    fgets(curLine,MAXLINE,inputFile);
  } 
  fclose(inputFile);
  return 1;
} 

int insertURL(urlType *myURL,char *newURL, int depth) {
  int new;
  int i;
  char *tempChar; 
  char tempURL[MAXURL];
  new=1;
  //Need to clean up & since otherwise the Linux sheell with give us problems 
  tempChar=strchr(newURL,'&');
  if (tempChar!=NULL) {
    if (strlen(newURL)<MAXURL-1) {
      tempChar[0]='\0';
      strncpy(tempURL,newURL,MAXURL);
      strncat(tempURL,"\\",MAXURL);
      tempChar[0]='&';
      strncat(tempURL,tempChar,MAXURL);
      strncpy(newURL,tempURL,MAXURL);
    }
    else {
      return 0;
    }
  }
  if (strstr(newURL,"All_languages")!=NULL) {
    return 0;
  } 
  else if (strchr(newURL,'#')!=NULL) {
    return 0;
  }
  for (i=0;i<myURL->numURLs;i++) {
    if (strcmp(myURL->followedURLs[i],newURL)==0) {
      new=0;
      break;
    }
  }
  if (new==1) {
    if (myURL->numURLs<(MAXNUMURLS-1)) {
      printf("inserting URL=%s\n",newURL);
      strcpy(myURL->followedURLs[myURL->numURLs],newURL);
      myURL->urlDepth[myURL->numURLs]=depth;
      myURL->numURLs++;
    }
  }

  return 0;
}


int insertWord(FILE *outputFile,char *tempLine) {
  if (strstr(tempLine,"Log in /")!=NULL) {
    return 1;
  }
  else if (strstr(tempLine,"Community portal")!=NULL) {
    return 1;
  }
  else if ((strstr(tempLine,"edit")!=NULL)&&(strlen(tempLine)==4)) {
    return 0;
  }
  else if (strstr(tempLine,"Discussion")!=NULL) {
    return 0;
  }
  else if (strstr(tempLine,"Edit")!=NULL) {
    return 0;
  }
  else if (strstr(tempLine,"History")!=NULL) {
    return 0;
  }
  else if (strstr(tempLine,"Index:")!=NULL) {
    return 0;
  }
  else if (strstr(tempLine,"Categories")!=NULL) {
    return 0;
  }
  else if (strstr(tempLine,"Category")!=NULL) {
    return 0;
  }
  else if (strstr(tempLine,"Language indexes")!=NULL) {
    return 0;
  }
  else if (strstr(tempLine,"Index")!=NULL) {
    return 0;
  }
  else if (strstr(tempLine,"next 200")!=NULL) {
    return 0;
  }
  else if (strstr(tempLine,"previous 200")!=NULL) {
    return 0;
  }
  else if (strlen(tempLine) < MINWORDSIZE) {
    if (isalnum(tempLine[0])!=0) {
      return 0;
    }
    else {
      printf("dicword=%s\n",tempLine);
      fprintf(outputFile,"%s\n",tempLine);
    }
  }
  else {
    printf("dicword=%s\n",tempLine);
    fprintf(outputFile,"%s\n",tempLine);
  }
  return 0;
}

int getSettings(FILE * outputFile,urlType *myURL) {
  int choice;
  char userInput[MAXUSERINPUT];
  int result; 

  printf("--------------------------------------------\n");
  printf("|Welcome to the WikiGrabber                |\n");
  printf("|Your one stop wordlist generator          |\n");
  printf("|Coded by Matt Weir                        |\n"); 
  printf("|Brought to you by Florida State University|\n");
  printf("|Use Responsibly.  Be Good!                |\n");
  printf("--------------------------------------------\n\n");
  printf("Do you want to create a wordlist based on:\n");
  printf("(1) Language\n");
  printf("(2) Subject\n");
  printf("(3) Quit\n");
  printf("<enter choice>:");

  choice = 0;
  while (choice==0) {
    fgets(userInput,MAXUSERINPUT-1,stdin);
    if (userInput!=NULL) { 
      if (userInput[0]=='1') {
        choice=1;
      }
      else if (userInput[0]=='2') {
        choice=2;
      }
      else if (userInput[0]=='3') {
        return -1;
      }
      else {
        printf("Please choose one of the options\n");
        printf("<enter choice>:");
      }
    }
    rewind(stdin);
  }
  if (choice==1) {
    if (pickLanguage(outputFile,myURL)==-1) {
      return -1;
    }
  }
  else if (choice==2) {
    result=pickSubject(outputFile,myURL);
    while (result==1) {
      result=pickSubject(outputFile,myURL);
    }
    if (result==-1){ 
      return -1;
    }
  }
  else {
    printf("I'm sorry, this lazy coder hasn't finished this feature yet\n");
    return -1;
  } 

  return 0;
}


int pickLanguage(FILE * outputFile,urlType *myURL) {
  char command[500];
  char userInput[MAXUSERINPUT];
  int choice;

  printf("\n\n\n\n\nCreating wordlist based on language\n"); 
  printf("-----------------------------------------------\n");
  printf("Where do you want to grab the words from?\n");
  printf("(1) Language Indexes\n");
  printf("    --Supposedly contains all the words, not always updated.\n");
  printf("    --Plus side, you don't have to worry about duplicates\n");
  printf("(2) Language Main Page\n");
  printf("    --Here you can refine your search to topics, or type of \n");
  printf("    --words, (verb, noun, etc).  Also sometimes has more words \n");
  printf("    --than the indexes, though sometimes not\n");
  printf("(3) Wikipedia in other Languages (not yet implimented)\n");
  printf("    --Search wiktionaries written in other languages\n");
  printf("(4) Quit\n");
  printf("<enter choice>:");

  choice = 0;
  while (choice==0) {
    fgets(userInput,MAXUSERINPUT-1,stdin);
    if (userInput!=NULL) {
      if (userInput[0]=='1') {
        choice=1;
      }
      else if (userInput[0]=='2') {
        choice=2;
      }
      else if (userInput[0]=='3') {
        choice=3;
      }
      else if (userInput[0]=='4') {
        return -1;
      }
      else {
        printf("Please choose one of the options\n");
        printf("<enter choice>:");
      }
    }
    rewind(stdin);
  }
  if (choice==1) {
    pickIndex(outputFile,myURL);
  }
  else if (choice==2) {
    pickTopic(outputFile,myURL);
  }
  else {
    printf("I'm sorry, this lazy coder hasn't finished this feature yet\n");
    return -1;
  }


  return 0;
}

int pickIndex(FILE *outputFile, urlType *myURL) {
  char command[MAXCOMMAND];
  char userInput[MAXUSERINPUT];
  char curLine[MAXLINE];
  char tempLine[MAXLINE];
  choiceType userChoice;
  int choice;
  int tempValue;
  int working;
  int i;
  int j;
  FILE * inputFile;
  char *startChar;
  char *endChar;

  ////////////////////////////////////////////////////
  //Delete any previous temporary files
  sprintf(command,"rm -f tempFile.txt"); 
  system(command);

  printf("\nGrabbing List of All Index Files\n");
  strncpy(myURL->siteURL,"http://en.wiktionary.org",MAXURL);
  snprintf(command,MAXCOMMAND,"wget -q -O tempFile.txt http://en.wiktionary.org/wiki/Index:All_languages");
  system(command);

  inputFile=fopen("tempFile.txt","r");
  if (inputFile==NULL) {
    printf("ERROR could not grab the index file.  Does your computer have a current network connection?\n");
    return -1;
  }
  userChoice.numChoice=0;
  fgets(curLine,MAXLINE,inputFile);
  while (!feof(inputFile)) {
    startChar=strstr(curLine,"/wiki/Index:");
    if (startChar!=NULL) {
      strncpy(tempLine,startChar,MAXLINE);
      endChar=strstr(tempLine,"\"");
      if (endChar!=NULL) {
        endChar[0]='\0';
        strncpy(userChoice.url[userChoice.numChoice],tempLine,MAXURL);
        working=1;
      }
    }
    if (working==1) {
      working=0;
      startChar=strstr(curLine,"title=\"Index:");
      if (startChar!=NULL) {
        strncpy(tempLine,startChar,MAXLINE);
        endChar = strstr(tempLine,"\">");
        if (endChar!=NULL) {
          endChar[0]='\0';
          strncpy(userChoice.topic[userChoice.numChoice],tempLine+13,MAXURL);
          working=1;
        }
      }
    }
    if (working==1) {
      working=0;
      startChar=strstr(startChar,"</a>");
      if (startChar!=NULL) {
        strncpy(tempLine,startChar,MAXLINE);
        endChar = strstr(tempLine,"</li>");
        if (endChar==NULL) {
          endChar = strstr(tempLine,"</p>");
        }
        if (endChar!=NULL) { 
          endChar[0]='\0';
          strncpy(userChoice.desc[userChoice.numChoice],tempLine+4,MAXDESC);
          if (strlen(userChoice.desc[userChoice.numChoice]) > 70) {
            strncpy(userChoice.desc[userChoice.numChoice]," - No longer being used\0",MAXDESC);
          }
          working=1;
        }
      }
    }
    if (working==1) {
      working=0;
      userChoice.numChoice++;
      if (userChoice.numChoice==MAXCHOICES) {
        printf("/n Wow, we exceeded the maximum number of choices.  Truncating Output\n");
        break;
      }
    }
    fgets(curLine,MAXLINE,inputFile);
  }

  //Print out the options
  for (i=0;i<userChoice.numChoice;i++) {
    printf("(%i) %s%s\n",i+1,userChoice.topic[i],userChoice.desc[i]);
  } 
  printf("(%i) Exit\n\n",i+1);
  printf("Please choose one of the options\n");
  printf("<enter choice>:");
  choice = -1;
  while (choice==-1) {
    fgets(userInput,MAXUSERINPUT-1,stdin);
    if (userInput!=NULL){
      endChar=strchr(userInput,'\n');
      if (endChar!=NULL) {
        endChar[0]='\0';
        tempValue=0;
        for (j=0;j<strlen(userInput);j++) {
          if (isdigit(userInput[j])==0){
            tempValue=-1;
            break;
          }
        }
        if (tempValue==0) {
          tempValue=atoi(userInput);
        }
      }
      else tempValue=-1;
    }
    else {
      (tempValue=-1);
    }
    if (tempValue!=-1) {
      if ((tempValue>0)&&(tempValue<userChoice.numChoice+2)) {
        choice=tempValue-1;
      }
    }
    if (choice==-1) {
      printf("Please choose one of the options\n");
      printf("<enter choice>:");
    }
    rewind(stdin);
  }


  if (choice<userChoice.numChoice) {
    printf("\nCreating %s Wordlist\n",userChoice.topic[choice]);
    snprintf(curLine,MAXLINE,"%s_wordlist.txt",userChoice.topic[choice]);
    outputFile=fopen(curLine,"w");
    if (outputFile==NULL) {
      printf("ERROR can not open outputfile for writing\n");
      return -1;
    }
    strncpy(myURL->fileName,curLine,MAXURL);
    strncpy(myURL->siteURL,"http://en.wiktionary.org",MAXURL);
    snprintf(myURL->mainURL,MAXURL,"http://en.wiktionary.org%s",userChoice.url[choice]);
    if (grabLanguage(outputFile,myURL)==-1) {
      return -1;
    }
    else {
      return 0;
    }
  }
  else if (choice==userChoice.numChoice) {
    printf("Quiting \n");
    return -1;
  }
  else {
    printf("I'm sorry, this lazy coder hasn't finished this feature yet\n");
    return -1;
  }
  return 0;
}


int grabLanguage(FILE *outputFile,urlType* myURL) {
  char tempString[200];
  char command[500];
  char checkURL[MAXURL];
  char *tempChar;
  int i;

  ///////////////////////////////////////////////////
  //Grab the first page
  tempChar = strstr(myURL->mainURL,"/wiki/");
  if ((strlen(myURL->mainURL)<MAXURL)&&(tempChar!=NULL)) {
    strncpy(myURL->followedURLs[0],tempChar,MAXURL);
    myURL->numURLs=1;
  }
  else {
    return -1;
  }
  snprintf(command,MAXURL,"wget -O tempFile.txt %s", myURL->mainURL);
  system(command);
  printf("downloaded the main URL\n");

  //////////////////////////////////////////////////
  //Proceed to spider the results, grabbing the next files, and the words
  getURLs(myURL);
  if (myURL->numURLs==1) {
    getWords(outputFile);
  }
  for (i=1;i<myURL->numURLs;i++) {
    getWords(outputFile);
    ///////////////////////////////////////////////
    //Grab the next webpage
    strncpy(checkURL,myURL->siteURL,MAXURL);
    strncat(checkURL,myURL->followedURLs[i],MAXURL);
    //////////////////////////////////////////////
    //Pause before Grabbing the next Webpage
    sleep(SLEEPVALUE);
    sprintf(command,"wget -q -O tempFile.txt %s",checkURL);
    system(command);
    printf("%s\n",command);
    ///////////////////////////////////////////////
    //Get the next list of URLs
    getURLs(myURL);
  }
  fclose(outputFile);
  printf("sorting output and removing duplicates\n");
  snprintf(command,MAXCOMMAND,"sort -u %s > tempFile.txt",myURL->fileName);
  system(command);
  snprintf(command,MAXCOMMAND,"cat tempFile.txt >%s",myURL->fileName);
  system(command);
  return 0;
}





int pickTopic(FILE *outputFile, urlType *myURL) {
  char command[MAXCOMMAND];
  char userInput[MAXUSERINPUT];
  char curLine[MAXLINE];
  char tempLine[MAXLINE];
  char filename[MAXURL];
  choiceType userChoice;
  int choice;
  int langChoice;
  int tempValue;
  int working;
  int i;
  int j;
  int totalChoice;
  FILE * inputFile;
  char *startChar;
  char *endChar;
  char options[20];  //1=nouns,2=verbs,3=adjectives,4=adverbs,5=sayings,6=swear words, 7=all
  char optionTitles[20][20];
  char checkURL[MAXURL];

  strncpy(optionTitles[1],"Nouns",20);
  strncpy(optionTitles[2],"Verbs",20);
  strncpy(optionTitles[3],"Adjectives",20);
  strncpy(optionTitles[4],"Adverbs",20);
  strncpy(optionTitles[5],"Sayings",20);
  strncpy(optionTitles[6],"Profanity",20);

  ////////////////////////////////////////////////////
  //Delete any previous temporary files
  sprintf(command,"rm -f tempFile.txt");
  system(command);

  printf("\nGrabbing List of All the Language Files\n");
  strncpy(myURL->siteURL,"http://en.wiktionary.org",MAXURL);
  snprintf(command,MAXCOMMAND,"wget -q -O tempFile.txt http://en.wiktionary.org/wiki/Index:All_languages");
  system(command);

  inputFile=fopen("tempFile.txt","r");
  if (inputFile==NULL) {
    printf("ERROR could not grab the index file.  Does your computer have a current network connection?\n");
    return -1;
  }
  userChoice.numChoice=0;
  fgets(curLine,MAXLINE,inputFile);
  while (!feof(inputFile)) {
    startChar=strstr(curLine,"/wiki/Category:");
    if (startChar!=NULL) {
      strncpy(tempLine,startChar,MAXLINE);
      endChar=strstr(tempLine,"\"");
      if (endChar!=NULL) {
        endChar[0]='\0';
        strncpy(userChoice.url[userChoice.numChoice],tempLine,MAXURL);
        working=1;
      }
    }
    if (working==1) {
      working=0;
      startChar=strstr(curLine,"title=\"Category:");
      if (startChar!=NULL) {
        strncpy(tempLine,startChar,MAXLINE);
        endChar = strstr(tempLine,"\">");
        if (endChar!=NULL) {
          endChar[0]='\0';
          strncpy(userChoice.topic[userChoice.numChoice],tempLine+16,MAXURL);
          working=1;
          //The following added on to get rid of some false positibes
          if (strstr(userChoice.topic[userChoice.numChoice],"Language indexes")!=NULL) {
            working=0;
          }
          else if (strstr(userChoice.topic[userChoice.numChoice],"Wiktionary")!=NULL) {
            working=0;
          }
          else if (strstr(userChoice.topic[userChoice.numChoice],"CJKV radicals")!=NULL) {
            working=0;
          }
        }
      }
    }
    if (working==1) {
      working=0;
      userChoice.numChoice++;
      if (userChoice.numChoice==MAXCHOICES) {
        printf("/n Wow, we exceeded the maximum number of choices.  Truncating Output\n");
        break;
      }
    }
    fgets(curLine,MAXLINE,inputFile);
  }
  fclose(inputFile);
  //Print out the options
  for (i=0;i<userChoice.numChoice;i++) {
    printf("(%i) %s\n",i+1,userChoice.topic[i]);
  }
  printf("(%i) Exit\n\n",i+1);
  printf("Please choose one of the options\n");
  printf("<enter choice>:");
  choice = -1;
  while (choice==-1) {
    fgets(userInput,MAXUSERINPUT-1,stdin);
    if (userInput!=NULL){
      endChar=strchr(userInput,'\n');
      if (endChar!=NULL) {
        endChar[0]='\0';
        tempValue=0;
        for (j=0;j<strlen(userInput);j++) {
          if (isdigit(userInput[j])==0){
            tempValue=-1;
            break;
          }
        }
        if (tempValue==0) {
          tempValue=atoi(userInput);
        }
      }
      else tempValue=-1;
    }
    else {
      (tempValue=-1);
    }
    if (tempValue!=-1) {
      if ((tempValue>0)&&(tempValue<userChoice.numChoice+2)) {
        choice=tempValue-1;
      }
    }
    if (choice==-1) {
      printf("Please choose one of the options\n");
      printf("<enter choice>:");
    }
    rewind(stdin);
  }
  if (choice==userChoice.numChoice) {
    printf("Quiting \n");
    return -1;
  } 
  langChoice=choice; 
  ////////////////////////////////////////////////////////
  // Get the next option, what category to choose  
  printf("\nGrabbing the Main Page\n",userChoice.topic[choice]);
  snprintf(command,MAXCOMMAND,"wget -q -O tempFile.txt http://en.wiktionary.org%s",userChoice.url[choice]);
  system(command);

  inputFile=fopen("tempFile.txt","r");
  if (inputFile==NULL) {
    printf("ERROR could not grab the index file.  Does your computer have a current network connection?\n");
    return -1;
  } 

  //Save the filename, reset the userChoice var
  strncpy(filename,userChoice.topic[choice],MAXURL);
  endChar=strchr(filename,' ');
  if (endChar!=NULL) {
    endChar[0]='\0';
  }
  userChoice.numChoice=0;
 
  for (i=0;i<20;i++) {
    options[i]=-1;
  } 
  //Start reading in the choices
  fgets(curLine,MAXLINE,inputFile);
  while (!feof(inputFile)) {
    startChar=strstr(curLine,"/wiki/Category:");
    if (startChar!=NULL) {
      strncpy(tempLine,startChar,MAXLINE);
      endChar=strstr(tempLine,"\"");
      if (endChar!=NULL) {
        endChar[0]='\0';
        strncpy(userChoice.url[userChoice.numChoice],tempLine,MAXURL);
        working=1;
      }
    }
    //assign the link to a category or drop it
    if (working==1) {
      working=0;
      if (strstr(userChoice.url[userChoice.numChoice],"_nouns")!=NULL) {
        working=1;
        userChoice.desc[userChoice.numChoice][0]='1';
        options[1]=1;
      }
      else if (strstr(userChoice.url[userChoice.numChoice],"_verbs")!=NULL) {
        working=1;
        userChoice.desc[userChoice.numChoice][0]='2';
        options[2]=1;
      }
      else if (strstr(userChoice.url[userChoice.numChoice],"adjectives")!=NULL) {
        working=1;
        userChoice.desc[userChoice.numChoice][0]='3';
        options[3]=1;
      }
      else if (strstr(userChoice.url[userChoice.numChoice],"adverbs")!=NULL) {
        working=1;
        userChoice.desc[userChoice.numChoice][0]='4';
        options[4]=1;
      }
      else if (strstr(userChoice.url[userChoice.numChoice],"phrases")!=NULL) {
        working=1;
        userChoice.desc[userChoice.numChoice][0]='5';
        options[5]=1;
      }
      else if (strstr(userChoice.url[userChoice.numChoice],"_proverbs")!=NULL) {
        working=1;
        userChoice.desc[userChoice.numChoice][0]='5';
        options[5]=1;
      }
      else if (strstr(userChoice.url[userChoice.numChoice],"swear")!=NULL) {
        working=1;
        userChoice.desc[userChoice.numChoice][0]='6';
        options[6]=1;
      }
      else if (strstr(userChoice.url[userChoice.numChoice],"profanity")!=NULL) {
        working=1;
        userChoice.desc[userChoice.numChoice][0]='6';
        options[6]=1;
      }
    }
    if (working==1) {
      working=0;
      userChoice.numChoice++;
      if (userChoice.numChoice==MAXCHOICES) {
        printf("/n Wow, we exceeded the maximum number of choices.  Truncating Output\n");
        break;
      }
    }
    fgets(curLine,MAXLINE,inputFile);
  }
  fclose(inputFile); 

  totalChoice=1; 
  printf("\n\nCreate %s Wordlist based upon:\n",filename);
  for (i=0;i<20;i++) {
    if (options[i]!=-1) {
      options[i]=totalChoice;
      printf("(%i) %s\n",totalChoice,optionTitles[i]);
      for (j=0;j<userChoice.numChoice;j++) {
        if (atoi(userChoice.desc[j])==i) {
          snprintf(userChoice.desc[j],5,"%d",totalChoice);
        }
      }
      totalChoice++;
    }
  }
  printf("(%i) Everything\n",totalChoice);
  totalChoice++;
  printf("(%i) Exit\n\n",totalChoice);
  printf("Please choose one of the options\n");
  printf("<enter choice>:");
  choice = -1;
  while (choice==-1) {
    fgets(userInput,MAXUSERINPUT-1,stdin);
    if (userInput!=NULL){
      endChar=strchr(userInput,'\n');
      if (endChar!=NULL) {
        endChar[0]='\0';
        tempValue=0;
        for (j=0;j<strlen(userInput);j++) {
          if (isdigit(userInput[j])==0){
            tempValue=-1;
            break;
          }
        }
        if (tempValue==0) {
          tempValue=atoi(userInput);
        }
      }
      else tempValue=-1;
    }
    else {
      (tempValue=-1);
    }
    if (tempValue!=-1) {
      if ((tempValue>0)&&(tempValue<=totalChoice)) {
        choice=tempValue;
      }
    }
    if (choice==-1) {
      printf("Please choose one of the options\n");
      printf("<enter choice>:");
    }
    rewind(stdin);
  }
  if (choice==totalChoice) {
    printf("Quiting \n");
    return -1;
  }

  //////////////////////////////////////////
  //Plug URLs in to spider
  myURL->numURLs=0;
  for (i=0;i<userChoice.numChoice;i++) {
    if (choice==(totalChoice+1)) {
      insertURL(myURL,userChoice.url[i],0);
    }
    else if (atoi(userChoice.desc[i])==choice) {
      insertURL(myURL,userChoice.url[i],0);
    }
  }

  printf("\nCreating %s Wordlist\n",userChoice.topic[langChoice]);
  for (i=0;i<20;i++) {
    if (options[i]==choice) {
      snprintf(filename,MAXLINE,"%s_%s_wordlist.txt",filename,optionTitles[i]);
    }
  }
  outputFile=fopen(filename,"w");
  if (outputFile==NULL) {
    printf("ERROR can not open %s for writing\n",filename);
    return -1;
  }
  strncpy(myURL->fileName,filename,MAXURL);
  strncpy(myURL->siteURL,"http://en.wiktionary.org",MAXURL);
  snprintf(myURL->mainURL,MAXURL,"http://en.wiktionary.org");

  for (i=0;i<myURL->numURLs;i++) {
    ///////////////////////////////////////////////
    //Grab the next webpage
    strncpy(checkURL,myURL->siteURL,MAXURL);
    strncat(checkURL,myURL->followedURLs[i],MAXURL);
    //////////////////////////////////////////////
    //Pause before Grabbing the next Webpage
    sprintf(command,"wget -q -O tempFile.txt %s",checkURL);
    system(command);
    printf("%s\n",command);
    ///////////////////////////////////////////////
    //Get the next list of URLs
    sleep(SLEEPVALUE);
    getURLs(myURL);
    getWords(outputFile);
  } 
  printf("sorting output and removing duplicates\n\n");
  fclose(outputFile);
  snprintf(command,MAXCOMMAND,"sort -u %s > tempFile.txt",myURL->fileName);
  system(command);
  snprintf(command,MAXCOMMAND,"cat tempFile.txt >%s",myURL->fileName);
  system(command);

  printf("All Done\n");
  
  return 0;
}


int pickSubject(FILE *outputFile,urlType *myURL) {
  char command[500];
  char userInput[MAXUSERINPUT];
  char tempUserInput[MAXUSERINPUT];
  char checkURL[MAXURL];
  int choice;
  char *tempChar;
  char *endChar;
  int tempValue;
  choiceType userChoice;
  int i;

  printf("\n\n\n\n\nCreating wordlist based on subject\n");
  printf("-----------------------------------------------\n");
  printf("Please enter your search word\n\n");
  printf("<enter search word>:");

  choice = 0;
  while (choice==0) {
    fgets(userInput,MAXUSERINPUT-1,stdin);
    if (userInput!=NULL) {
      tempChar=strchr(userInput,'\n'); 
      if (tempChar!=NULL) {
        tempChar[0]='\0';
      }
      if (strlen(userInput)>2) {    
        choice=1;
      }
      else {
       printf("Please enter your search word\n");
        printf("<enter search>:");
      } 
    }
    else {
      printf("Please enter your search word\n");
      printf("<enter search>:");
    }
    rewind(stdin);
  }
  strncpy(myURL->siteURL,"http://en.wikipedia.org",MAXURL);
  //snprintf(myURL->mainURL,MAXURL,"http://en.wiktionary.org%s",userChoice.url[choice]);
 
  //Clean up user input
  tempChar=strchr(userInput,' ');
  while (tempChar!=NULL) {
    if (strlen(userInput)<MAXUSERINPUT-1) {
      tempChar[0]='_';
      if (tempChar[1]!='\0') {
        if (islower(tempChar[1])!=0) {
          tempChar[1]=toupper(tempChar[1]);
        }
      }
    }
    else {
      tempChar[0]='\0';
      printf("\nSearch term too long.  Cutting it off after the first space\n"); 
    }
    tempChar=strchr(userInput,' ');
  }
  if (islower(userInput[0])!=0) {
    userInput[0]=toupper(userInput[0]);
  }
  printf("%s\n",userInput);
  snprintf(checkURL,MAXURL,"/wiki/%s",userInput);

  //Parse the response from wiki to find out if there are any options
  //for the user to choose between
  choice=findSubjects(myURL,&userChoice,userInput);
  if (choice==-1) {
    return -1;
  }
  else if (choice==0) {          //If the search term returned one main page
    insertURL(myURL,checkURL,0);
    spiderdata(outputFile,myURL);
  }
  else if (choice==1) {          //If wiki can't find anything, even related terms
    printf("Your search query did not return any results\n");
    return 1;
  }
  else if (choice==3) {
     printf("disambiguation\n");
     strncat(userInput,"_%28disambiguation%29",MAXURL);
     choice=findSubjects(myURL,&userChoice,userInput);
     printf("choice=%i\n",choice);
  }  
  if ((choice==2)||(choice==3)) {          //If there are multiple subjects that the user has to choose between
    printf("Your search term returned multiple results\n\n");
    printf("Please select the category that closest matches what you\n");
    printf("create your wordlist based upon\n");
    printf("----------------------------------------------\n");
    for (i=0;i<userChoice.numChoice;i++) {
      printf("(%i) %s%s\n",i+1,userChoice.topic[i],userChoice.desc[i]);
    }
    printf("(%i) Search using a different term\n",i+2);
    printf("(%i) Exit\n",i+3);

    printf("<enter choice>:");
    choice = -1;
    while (choice==-1) {
      fgets(userInput,MAXUSERINPUT-1,stdin);
      if (userInput!=NULL){
        endChar=strchr(userInput,'\n');
        if (endChar!=NULL) {
          endChar[0]='\0';
          tempValue=0;
          for (i=0;i<strlen(userInput);i++) {
            if (isdigit(userInput[i])==0){
              tempValue=-1;
              break;
            }
          }
          if (tempValue==0) {
            tempValue=atoi(userInput);
          }
        }
        else tempValue=-1;
      }
      else {
        (tempValue=-1);
      }
      if (tempValue!=-1) {
        if ((tempValue>0)&&(tempValue<userChoice.numChoice+4)) {
          choice=tempValue-1;
        }
      }
      if (choice==-1) {
        printf("Please choose one of the options\n");
        printf("<enter choice>:");
      }
      rewind(stdin);
    }
    if (choice==userChoice.numChoice+2) { //Quitting
      return 0;
    }
    else if (choice==userChoice.numChoice+1) { //Search using a different term
      printf("searching useing a different term\n");
      return 1;
    }
    else { //User made a choice
      insertURL(myURL,userChoice.url[choice],0);
      spiderdata(outputFile,myURL);
    }

  }  
 
  return 0;
}

////////////////////////////////////////////////////////////////
//Returns which subjects are available given a user search term
//
//Returns 0 = ready to spider
//Returns -1 = error
//Returns 1 = no subjects
//Returns 2 = multiple subjects
//Returns 3 = disambiguation page exists
int findSubjects(urlType *myURL,choiceType *userChoice,char *userInput) {
  char command[500];
  char curLine[MAXLINE];
  char tempLine[MAXLINE];
  char tempUserInput[MAXUSERINPUT];
  char checkURL[MAXURL];
  int choice;
  char *startChar;
  char *endChar;
  int isSearch;
  int i;
  FILE *inputFile;

  snprintf(checkURL,MAXURL,"%s/wiki/%s",myURL->siteURL,userInput);
  sprintf(command,"wget -q -O tempFile.txt %s",checkURL);
  system(command);
  snprintf(checkURL,MAXURL,"/wiki/%s",userInput);



  //Read the input, determine if it is a search page, blank page, or main page
  inputFile=fopen("tempFile.txt","r");
  if (inputFile==NULL) {
    printf("ERROR could not grab the index file.  Does your computer have a current network connection?\n");
    return -1;
  }
  isSearch=0;
  fgets(curLine,MAXLINE,inputFile);
  while (!feof(inputFile)) {
    startChar=strstr(curLine,"<div class=\"noarticletext\">");
    if (startChar!=NULL) {    //It is a blank page
      printf("\nblank page\n");
      return 1;
    }
    startChar=strstr(curLine,"This <a href=\"/wiki/Wikipedia:Disambiguation\" title=\"Wikipedia:Disambiguation\">disambiguation</a> page");
    if (startChar!=NULL) {    //It is a search page
      isSearch=1;
    }
    startChar=strstr(curLine,"_%28disambiguation%29\" title=");
    if (startChar!=NULL) {    //a disambiguation page exists
      startChar=strstr(curLine,"[c]");
      if (startChar==NULL) {
        startChar=strstr(curLine,"Talk:");
        if (startChar==NULL) {
          startChar=strstr(curLine,"Special:");
          if (startChar==NULL) {
            if (isSearch!=1) {
              isSearch=-1;
            }
          }
        }
      }
    }
    fgets(curLine,MAXLINE,inputFile);
  }
  if (isSearch==0) { //Ready to spider
    printf("\nReady to spider\n");
    return 0;
  }
  else if (isSearch==-1) {
    return 3;
  }
  fclose(inputFile);
  //Else is a search page, go ahead and figure out what the categories are
  printf("\ndoing a search\n");

  inputFile=fopen("tempFile.txt","r");
  if (inputFile==NULL) {
    printf("ERROR could not grab the index file.  Does your computer have a current network connection?\n");
    return -1;
  }
  userChoice->numChoice=0;
  while (!feof(inputFile)) {
    isSearch=0;
    startChar=strstr(curLine,"<li><a href=\"/wiki/");
    if (startChar!=NULL) {    //Save this option, first get the URL
      startChar=startChar+13;
      strncpy(tempLine,startChar,MAXLINE);
      endChar=strchr(tempLine,'\"');
      if (endChar!=NULL) {
        endChar[0]='\0';
        strncpy(userChoice->url[userChoice->numChoice],tempLine,MAXURL);
        isSearch=1;
      }        
    }
    if (isSearch==1) {
      isSearch=0;
      startChar=strstr(startChar,"title=\"");
      if (startChar!=NULL) {
        startChar=startChar+7;
        strncpy(tempLine,startChar,MAXLINE);
        endChar=strstr(tempLine,"\">");
        if (endChar!=NULL) {
          endChar[0]='\0';
          isSearch=1;
          strncpy(userChoice->topic[userChoice->numChoice],tempLine,MAXURL);
          printf("UserChoice topic=%s\n",userChoice->topic[userChoice->numChoice]);
        }
      }
    }
    if (isSearch==1) {
      startChar=strstr(startChar,"</a>");
      if (startChar!=NULL) {
        startChar=startChar+4;
        strncpy(tempLine,startChar,MAXLINE);
        endChar=strstr(tempLine,"</li>");
        if (endChar!=NULL) {
          endChar[0]='\0';
          startChar=strchr(tempLine,'<');
          while(startChar!=NULL) {
            startChar[0]='\0';
            startChar=strchr(startChar+1,'>');
            if (startChar!=NULL) {
              strncat(tempLine,startChar+1,MAXURL);
              startChar=strchr(tempLine,'<');
            }
          }
            
          strncpy(userChoice->desc[userChoice->numChoice],tempLine,MAXURL);
          if (userChoice->numChoice<(MAXCHOICES-1)) {
            userChoice->numChoice++;
          }
        }
      }
    }
    fgets(curLine,MAXLINE,inputFile);
  }

  return 2;
}

int spiderdata(FILE *outputFile, urlType *myURL) {
  int i;
  int curDepth;
  char fileName[MAXURL];
  char checkURL[MAXURL];
  char command[500];

  //Add a gui option to select these later
  myURL->depth=2;
  myURL->mode=1;
  strncpy(myURL->fileName,"subject",MAXURL);
  //end add a gui section

  ///////Open the file for writing
  snprintf(fileName,MAXURL,"%s_wordlist.txt",myURL->fileName);
  strncpy(myURL->fileName,fileName,MAXURL);
  printf("\nCreating %s Wordlist\n",fileName);
  outputFile=fopen(fileName,"w");
  if (outputFile==NULL) {
    printf("ERROR can not open %s for writing\n",fileName);
    return -1;
  }

  ////////Proceed to spider the results
  for (i=0;i<myURL->numURLs;i++) {
    curDepth=myURL->urlDepth[i];
    ///////////////////////////////////////////////
    //Grab the next webpage
    strncpy(checkURL,myURL->siteURL,MAXURL);
    strncat(checkURL,myURL->followedURLs[i],MAXURL);
    //////////////////////////////////////////////
    //Pause before Grabbing the next Webpage
    sprintf(command,"wget -q -O tempFile.txt %s",checkURL);
    system(command);
    printf("%s\n",command);
    ///////////////////////////////////////////////
    //Get the next list of URLs
    sleep(SLEEPVALUE);
    getSubjectURLs(myURL,curDepth);
    getSubjectWords(outputFile);    

  }
  fclose(outputFile);
  printf("sorting output and removing duplicates\n");
  snprintf(command,MAXCOMMAND,"sort -d -u %s > tempFile.txt",myURL->fileName);
  system(command);
  snprintf(command,MAXCOMMAND,"cat tempFile.txt >%s",myURL->fileName);
  system(command);
  //diff subject_wordlist.txt basic_wordlist.txt | grep "< *" | cut -c 3-20
  return 0;
}

int getSubjectWords(FILE *outputFile) {
  FILE * inputFile;
  char *startChar1;
  char *startChar2;
  char *startChar;
  char *endChar;
  char tempLine[MAXLINE];
  char curLine[MAXLINE];
  int done;
  printf("getword\n");
  done=0;
  inputFile=fopen("tempFile.txt","r");
  if (inputFile==NULL) {
    printf("ERROR can not open outputfile for writing\n");
    return -1;
  }
  fgets(curLine,MAXLINE,inputFile);
  while (!feof(inputFile)) {
    startChar=curLine;
    curLine[MAXLINE-1]='\0';
    while ((startChar!=NULL)&&(startChar[0]!='\0')) {
/*      endChar=strchr(startChar,'<');
      while (endChar!=NULL) {
        endChar[0]=' ';
        endChar=strchr(startChar,'<');
      }
      endChar=strchr(startChar,'>');
      while (endChar!=NULL) {
        endChar[0]=' ';
        endChar=strchr(startChar,'>');
      }
      endChar=strchr(startChar,'\"');
      while (endChar!=NULL) {
         endChar[0]=' ';
         endChar=strchr(startChar,'\"');
      } 
      endChar=strchr(startChar,':');
      while (endChar!=NULL) {
         endChar[0]=' ';
         endChar=strchr(startChar,':');
      }
      endChar=strchr(startChar,'/');
      while (endChar!=NULL) {
         endChar[0]=' ';
         endChar=strchr(startChar,'/');
      }
      endChar=strchr(startChar,'\\');
      while (endChar!=NULL) {
         endChar[0]=' ';
         endChar=strchr(startChar,'\\');
      }
      endChar=strchr(startChar,'=');
      while (endChar!=NULL) {
         endChar[0]=' ';
         endChar=strchr(startChar,'=');
      }
      endChar=strchr(startChar,'_');
      if (endChar!=NULL) {
         endChar[0]=' ';
      }
      endChar=strchr(startChar,'-');
      if (endChar!=NULL) {
         endChar[0]=' ';
      }
      endChar=strchr(startChar,',');
      if (endChar!=NULL) {
         endChar[0]=' ';
      }
      endChar=strchr(startChar,'\n');
      while (endChar!=NULL) {
         endChar[0]=' ';
         endChar=strchr(startChar,'\n');
      }
      endChar=strchr(startChar,'%');
      while (endChar!=NULL) {
         endChar[0]=' ';
         endChar=strchr(startChar,'%');
      }
      endChar=strchr(startChar,'\t');
      while (endChar!=NULL) {
         endChar[0]=' ';
         endChar=strchr(startChar,'\t');
      }
      endChar=strchr(startChar,'\'');
      while (endChar!=NULL) {
         endChar[0]=' ';
         endChar=strchr(startChar,'\'');
      }
      endChar=strchr(startChar,'`');
      while (endChar!=NULL) {
         endChar[0]=' ';
         endChar=strchr(startChar,'`');
      }
*/
      /////Convert all text to lowercase and remove non-alpha characters
      endChar=startChar;
      while (endChar[0]!='\0') {
        if (isalnum(endChar[0])==0) {
          endChar[0]=' ';
        }
        if (isupper(endChar[0])!=0) {
          endChar[0]=tolower(endChar[0]);
        }
        endChar=endChar+1;
      }

      /////Remove leading spaces
      while ((startChar[0]!='\0')&&(startChar[0]==' ')) {
        startChar=startChar+1;
      }
      if (startChar[0]=='\0') {
        break;
      }
   
      /////Find the end of the word
      endChar=strchr(startChar,' ');
      if (endChar!=NULL) {
        endChar[0]='\0';
        if (strlen(startChar)<MAXWORDSIZE) {
          insertWord(outputFile,startChar);
        }
        startChar=endChar+1;
      }
      else {
        if (strlen(startChar)<MAXWORDSIZE) {
          insertWord(outputFile,startChar);
        }
        startChar=NULL;
      }
    }
    fgets(curLine,MAXLINE,inputFile);
  }
  fclose(inputFile);
  return 0;
}

int getSubjectURLs(urlType *myURL,int curDepth) {
  char curLine[MAXLINE];
  char backupLine[MAXLINE];
  char tempLine[MAXLINE];
  FILE * inputFile;
  char * startChar;
  char * endChar;
  char currentURL[MAXURL];


  if (curDepth == myURL->depth) { //If you have hit the maximum depth already
    return 1;
  }

  //////Open up the downloaded file to parse it
  inputFile=fopen("tempFile.txt","r");
  if (inputFile==NULL) {
    printf("ERROR can not open tempfile to read in data\n");
    return -1;
  }
  fgets(curLine,MAXLINE,inputFile);
  while (!feof(inputFile)) {
    startChar=strstr(curLine,"Main article: <a href=\""); //First check for "Super" links.  Valid for all search types
    while (startChar!=NULL) {
      strcpy(tempLine,startChar+23);
      endChar=strchr(tempLine,'\"');
      if (endChar!=NULL) {
        endChar[0]='\0';
        insertURL(myURL,tempLine,curDepth+1);
        printf("***********inserting URL=%s\n",tempLine);
      }
      startChar=strstr(startChar+23,"Main article: <a href=\"");
    }

    fgets(curLine,MAXLINE,inputFile);
  }
  fclose(inputFile);
  return 0;
}

///////////////////////////////////////////////////////////
//Used to insert an URL into the datastructure
//for urlLevel, 0=always insert regardless of mode
//              1=cautions, depends on mode if inserted
int insertSubjectURL(urlType *myURL,char *newURL, char *description, int depth, int urlLevel) {
  int new;
  int i;
  char *tempChar; 
  char tempURL[MAXURL];
  new=1;
  int choice;
  char userInput[MAXURL];
  //Need to clean up & since otherwise the Linux sheell with give us problems 
  tempChar=strchr(newURL,'&');
  if (tempChar!=NULL) {
    if (strlen(newURL)<MAXURL-1) {
      tempChar[0]='\0';
      strncpy(tempURL,newURL,MAXURL);
      strncat(tempURL,"\\",MAXURL);
      tempChar[0]='&';
      strncat(tempURL,tempChar,MAXURL);
      strncpy(newURL,tempURL,MAXURL);
    }
    else {
      return 0;
    }
  }
  if (strstr(newURL,"All_languages")!=NULL) {
    return 0;
  } 
  else if (strchr(newURL,'#')!=NULL) {
    return 0;
  }
  for (i=0;i<myURL->numURLs;i++) {
    if (strcmp(myURL->followedURLs[i],newURL)==0) {
      new=0;
      break;
    }
  }
  /////////////////////////////////////////////////////
  // if always inserted
  if ((new==1)&&(urlLevel==0)) {
    if (myURL->numURLs<(MAXNUMURLS-1)) {
      printf("inserting URL=%s\n",newURL);
      strcpy(myURL->followedURLs[myURL->numURLs],newURL);
      myURL->urlDepth[myURL->numURLs]=depth;
      myURL->numURLs++;
    }
  }
  //////////////////////////////////////////////////////
  // if not always inserted, but user directed, check to see if the user has rejected it before
  if ((new==1)&&(urlLevel==1)&&(myURL->mode==3)) {
    for (i=0;i<myURL->numRejectedURLs;i++) {
      if (strcmp(myURL->rejectedURLs[i],newURL)==0) {
        new=0;
        break;
      }
    }
  }
  //////////////////////////////////////////////////////
  //Need user approval to continue
  if ((new==1)&&(urlLevel==1)&&(myURL->mode==3)) {
    printf("\n\n*************************************\n");
    printf("User Input Required\n");
    printf("Do you want to spider the following link?\n");
    printf("<topic>: %s\n",description);
    printf("< (Y)es, or (N)o > :");
    choice = 0;
    while (choice==0) {
      fgets(userInput,MAXUSERINPUT-1,stdin);
      if (userInput!=NULL) {
        tempChar=strchr(userInput,'\n');
        if (tempChar!=NULL) {
          tempChar[0]='\0';
        }
        if (isupper(userInput[0])!=0) {
          userInput[0]=tolower(userInput[0]); 
        }
        if (userInput[0]=='y') {
          choice=1;
        }
        else if (userInput[0]=='n') {
          choice=2;
        }
        else {
          printf("<Do you want to spider this link?  (Y)es, (N)o >:");
        }
      }
      else {
        printf("<Do you want to spider this link?  (Y)es, (N)o >:");
      }
      rewind(stdin);
    }
    if (choice==1) {
      if (myURL->numURLs<(MAXNUMURLS-1)) {
        printf("inserting URL=%s\n",newURL);
        strcpy(myURL->followedURLs[myURL->numURLs],newURL);
        myURL->urlDepth[myURL->numURLs]=depth;
        myURL->numURLs++;
      }
    } 
    else if (choice==2) {
      if (myURL->numRejectedURLs<(MAXNUMURLS-1)) {
        strcpy(myURL->rejectedURLs[myURL->numRejectedURLs],newURL);
        myURL->numRejectedURLs++;
      }
    }    
  }
  return 0;
}

